# This is required by the main troff2html
# John M. Troyer
# Copyright 1994 The Regents of the University of California
# please see the file named COPYRIGHT

###### Macro->HTML subroutines

# If you have additional macros in your files that should behave like 
# the ones defined below, add them to this associative array.
# For instance, if you have a macro .ZZ which can be ignored, just add a line
#   'ZZ', 'ignore',

%macrosubs = (
	     # ms macros
	      'PP', 'para',	# paragraph
	      'LP', 'para',	# paragraph
	      'IP', 'indentpara', # indented para
	      'QP', 'quotepara', # quoted para
	      'XP', 'para',	# extended para treaded like normal
	      'AL', 'ALpara',	# like ip
	      'AR', 'ALpara',	# like ip
	      '2P', 'ALpara:2P', # like ip
	      'SH', 'mssection:sh',
	      'NH', 'mssection:nh',
	      # NH not quite -- need alternate syntax
	     'RP', 'ignore',	# indent right (fake with lists?)
	     'RE', 'ignore',	# indent left (fake with lists?)
	     'FS', 'pushdelayed:(f', # begin footnote
	     'FE', 'popdelayed:)f', # end footnote
	     'I', 'font:i',	# italic same syntax as me
	     'B', 'font:b',	# bold
	     'UL', 'font:u',	# underline'
	     'LG', 'ignore',	# size change
	     'SM', 'ignore',	# size change
	     'NL', 'ignore',	# normal size
	     'BX', 'ignore',	# box. WRONG should write $args
	     'B1', 'ignore',	# begin boxed (blockquote?)
	     'B2', 'ignore',	# end boxed
	     #  Need to format these, eh?
	     # RP means go into state, first para afterwards make a new page
	     # these all take $text as args
	     # 'RP', 'ignore',	# cover sheet
	     # TL heading or ignore?
	     # AU format or ignore?
	     # AI format or ignore?
	     # AB format or ignore?
	     # AE end abstract
	     # ND format or ignore?
	     # DA
	     # XS toc entry in $text
	     # XA same
	     # XE same
	     # PX print TOC
	     # TC same
	     '2C', 'ignore',	# 2 column
	     '1C', 'ignore',	# 1 column
	     'MC', 'ignore',	# multi column
	     # can ignore keeps because there's always enough room
	     'KS', 'ignore',	# keep
	     'KF', 'ignore',	# floating keep
	     'KE', 'ignore',	# end keep
	     # DS, LD, ID, CD, BD, DE like me, but with generic ender
	     'P1', 'ignore',	# header
	     'EH', 'ignore',	# even header
	     'OH', 'ignore',	# odd header
	     'EF', 'ignore',	# even footer
	     'OF', 'ignore',	# odd footer
	     'TM', 'ignore',	# thesis mode
	     'CT', 'ignore',	# chapter title? use?
	     # pic, chem, grap, psfig
	     #'IX', index                                                              
	     # me macros 
	     # paragraphs
	     'lp', 'para',	# paragraph
	     'pp', 'para',	# paragraph
	     'ip', 'indentpara', # indented para (usually dl)
	     'np', 'list',	# ordered list
	     'bu', 'list',	# unordered list
	     # section headings
	     'sh', 'section',	# section header
	     'sx', 'setdepth',	# set section depth
	     'uh', 'section:uh', # unnumbered section
	     '$p', 'ignore',	# print section heading hook
	     '$0', 'ignore',	# para hook
	     '$1', 'ignore',	# section hook
	     '$2', 'ignore',	# section hook
	     '$3', 'ignore',	# section hook
	     '$4', 'ignore',	# section hook
	     '$5', 'ignore',	# section hook
	     '$6', 'ignore',	# section hook
	     # headers/footers
	     'he', 'ignore',	# 3part header
	     'fo', 'ignore',	# footer
	     'eh', 'ignore',	# even page header
	     'oh', 'ignore',	# odd page header
	     'ef', 'ignore',	# even page footer
	     'of', 'ignore',	# odd page footer
	     'hx', 'ignore',	# supress head/foot
	     'm1', 'ignore',	# spacing
	     'm2', 'ignore',	# spacing
	     'm3', 'ignore',	# spacing
	     'm4', 'ignore',	# spacing
	     'ep', 'ignore',	# end but don't flush
	     '$h', 'ignore',	# header hook
	     '$f', 'ignore',	# footer hook
	     '$H', 'ignore',	# top of page hook
	     # displays
	     '(l', 'begindisplay', # list
	     ')l', 'enddisplay', # list
	     '(q', 'beginquote', # quote
	     ')q', 'endquote', # quote
	     '(b', 'begindisplay', # block
	     ')b', 'enddisplay', # block
	     '(z', 'begindisplay', # floating keep
	     ')z', 'enddisplay', # floating keep
	     '(c', 'begincenter', # centered block
	     ')c', 'endcenter', # centered block
	     # annotations
	     # the () will give us problems if used in a regexp
	     '(d', 'pushdelayed:d', # delayed text
	     ')d', 'popdelayed:d',	# delayed text
	     'pd', 'printdelayed', # print delayed
	     '(f', 'pushdelayed:f', # begin footnote
	     ')f', 'popdelayed:f',	# end footnote
	     '$s', 'ignore',	# footnote hook
	     '(x', 'pushdelayed:x', # index
	     ')x', 'popdelayed:x', # index
	     'xp', 'printindex', # print index
	     # columns
	     '2c', 'ignore',	# 2 columns
	     '1c', 'ignore',	# 1 column
	     'bc', 'ignore',	# begin column
	     # fonts
	     'sz', 'ignore',	# set size (could be faked with headers)
	     'r', 'font',	# roman 
	     'i', 'font',	# italic
	     'b', 'font',	# bold
	     'rb', 'font:b',	# bold
	     'u', 'font',	# underline
	     'q', 'quote',	# quote a word
	     'bi', 'font',	# bold italic
	     'bx', 'font:u',	# boxed (underlined)
	     'sm', 'ignore',	# smaller size (could be faked with headers)
	     # roff support
	     'ix', 'ignore',	# indent == roff 'in'
	     'bl', 'spbara',	# blank == roff 'sp'
	     'pa', 'para',	# page == roff 'bp'
	     'ro', 'ignore',	# roman page no
	     'ar', 'ignore',	# arabic page no
	     'n1', 'ignore',	# number lines
	     'n2', 'ignore',	# number lines
	     'sk', 'ignore',	# skip a page
	     # preprocessor
	     'EQ', 'beginpreproc:eqn', # eqn start
	     'EN', 'endpreproc:eqn', # eqn end
	     'TS', 'beginpreproc:tbl', # tbl start
	      'TH', 'echocommand',	# tbl header end
	     'TE', 'endpreproc:tbl', # tbl end
	     'PS', 'beginpreproc:pic', # pic start
	     'PE', 'endpreproc:pic', # pic end
	     # ideal, gremlin too archaic even too ignore
	     # misc
	     're', 'ignore',	# reset tabs
	     'ba', 'ignore',	# base indent (could be faked with lists)
	     'xl', 'ignore',	# line length
	     'll', 'ignore',	# line length
	     'hl', 'horizline',	# horiz rule
	     'lh', 'ignore',	# letterhead
	     'lo', 'macro',	# load macro file
	     'sc', 'ignore',	# load special character
	     # standard papers
	     'tp', 'ignore',	# title page
	     'th', 'ignore',	# thesis mode
	     '++', 'ignore',	# set section depth
	     '+c', 'ignore',	# chapter title
	     '$c', 'ignore',	# print chapter no 
	     '$C', 'ignore',	# print chapter no hook
	     'ac', 'ignore',	# ACM output

	     # raw troff macros
	     # in order listed in BSD supplementary docs 

	     # font/character size control
	     # some of these could be faked with headers
	     'ps', 'ignore',	# change point size
	     'fz', 'ignore',	# change font F size
	     'ss', 'ignore',	# space-character size set
	     'cs', 'constantwidth', # constant width font
	     'bd', 'ignore',	# embolden font F
	     'ft', 'change_font:$args', # change to font F 
	     'fp', 'ignore',	# font F mapped to number N
	     # page control
	     'pl', 'ignore',	# page length
	     'bp', 'para',	# eject current page
	     'pn', 'ignore',	# next page number
	     'po', 'ignore',	# page offset
	     'ne', 'ignore',	# need vertical space
	     'mk', 'ignore',	# mark vertical space in register
	     'rt', 'ignore',	# return to marked space
	     # text filling
	     'br', 'breakline',	# breakline
	     'fi', 'fillmode:0', # fill line (normal) mode
	     'nf', 'fillmode:1', # nofill mode (linebreaks)
	     'ad', 'ignore',	# adjust lines
	     'na', 'ignore',	# no adjust
	     'ce', 'center',	# center N lines	
	     # vertical spacing
	     'vs', 'ignore',	# baseline spacing
	     'ls', 'ignore',	# leave space
	     'sp', 'sppara',	# vertical space
	     'sv', 'ignore',	# save vertical space
	     'os', 'ignore',	# output saved space
	     'ns', 'ignore',	# no-space mode
	     'rs', 'ignore',	# restore space mode
	     # line length
	     #'ll', 'ignore',	# line length
	     'in', 'ignore',	# indent (could be faked with lists) 
	      'ti', 'para',	# temporary indent; treat as paragraph
	     # macros
	     'de', 'macro', # macro (Not supported!)
	     'am', 'macro', # append to macro (Not supported!)
	     'ds', 'string',	# define string
	     'as', 'string',	# append to string
	     'rm', 'remove',	# delete string
	     'rn', 'rename',	# rename string
	     'di', 'macro', # divert to macro
	     'da', 'macro', # divert & append to macro
	     'wh', 'ignore',	# location trap
	     'ch', 'ignore',	# change trap
	     'dt', 'ignore',	# diversion trap
	     'it', 'ignore',	# input-line count trap
	     'em', 'macro', # macro
	     # number registers
	     'nr', 'ignore',	# set register
	     'af', 'ignore',	# assign format to register
	     'rr', 'ignore',	# remove register
	     # tabs
	     'ta', 'ignore',	# tab set
	     'tc', 'ignore',	# tab repetition char
	     'lc', 'ignore',	# leader repetition char
	     'fc', 'ignore',	# field delimiter
	     # input/output
	     'ec', 'ignore',	# escape character
	     'eo', 'ignore',	# turn off escape
	     'lg', 'ignore',	# ligature mode
	     'ul', 'font:i',	# underline (italic)  NOT RIGHT
	     'cu', 'font:i',	# continuous underline (italic)
	     'uf', 'ignore',	# underline font
	     'cc', 'ignore',	# control char
	     'c2', 'ignore',	# nobreak char
	     'tr', 'ignore',	# translate a to b
	     # hyphenation
	     'nh', 'ignore',	# no hyphenation
	     'hy', 'ignore',	# hyphenate
	     'hc', 'ignore',	# hyph char
	     'hw', 'ignore',	# hyph exceptions
	     # three part titles
	     'tl', 'ignore',	# three part title
	     'pc', 'ignore',	# page number char
	     'lt', 'ignore',	# title length
	     # output line numbering
	     'nm', 'ignore',	# numberline mode
	     'nn', 'ignore',	# do not number N lines
	     # conditional
	     'if', 'ignore',	# if
	     'ie', 'ignore',	# ifelse
	     'el', 'ignore',	# else
	     # environment switching
	     'ev', 'ignore',	# environment stack
	     # insertions
	     'rd', 'ignore',	# read insertion
	     'ex', 'ignore',	# exit
	     # i/o file switching
	     'so', 'source:$args', # source file stack
	     'nx', 'ignore',	# next file
	     'pi', 'ignore',	# pipe
	     # misc
	     'mc', 'ignore',	# margin char
	     'tm', 'ignore',	# to stderr (terminal)
	     'ig', 'ignore',	# ignore
	     'pm', 'ignore',	# print macros
	     'ab', 'ignore',	# abort
	     'fl', 'ignore',	# flush
	     'dummy', 'ignore');

1;


